{g-vars.i &vsh = "shared"}
{show-header-frame-def.i}

screen-title = "Guest Info Management".

def var selection as char init ?.

def buffer b-guest for guest.

def var g-id like guest.guest-id.
def var g-f-n like guest.first-name.
def var g-l-n like guest.last-name.
def var g-dob like guest.date-of-birth.
def var g-id-type like guest.id-type no-undo.
def var g-id-# like guest.id-number no-undo.
def var g-phone-# like guest.phone-number.
def var g-street-1 like guest.street-1.
def var g-street-2 like guest.street-2.
def var g-city like guest.city.
def var g-state like guest.state.
def var g-zip like guest.zip.
def var g-country like guest.country.

form g-id g-id-type view-as combo-box list-item-pairs "Passport","1","State ID","2","Driver's License","3","Unknown","4" format ">>>>>>>>>>>>>>>999" g-id-# format "x(15)" skip (2) 
     g-f-n skip g-l-n skip
     g-dob g-phone-# skip(2)
     g-street-1 at row 9 col 15 colon-aligned
     g-street-2 at row 10 col 15 colon-aligned
     g-city at row 11 col 15 colon-aligned
     g-state at row 12 col 15 colon-aligned
     g-zip at row 13 col 15 colon-aligned
     g-country at row 14 col 15 colon-aligned 
   with frame f-guest side-labels size 78 by 20 at row 2 col 1.

view frame f-guest.

procedure refresh.
   if not avail(guest) then do:
      clear frame f-guest all no-pause.
      return.
   end.

   g-id = guest.guest-id.
   g-f-n = guest.first-name.
   g-l-n = guest.last-name.
   g-dob = guest.date-of-birth.
   g-id-type = guest.id-type.
   g-id-# = guest.id-number.
   g-phone-# = guest.phone-number.
   g-street-1 = guest.street-1.
   g-street-2 = guest.street-2.
   g-city = guest.city.
   g-state = guest.state.
   g-zip = guest.zip.
   g-country = guest.country.
   
   display g-id g-f-n g-l-n g-dob g-id-type g-id-# g-phone-# 
           g-street-1 g-street-2 g-city g-state g-zip g-country 
      with frame f-guest. 
end.

define query q-guest for guest scrolling.
open query q-guest for each guest use-index idx-g-id.
get first q-guest.

run refresh.

PROC:
repeat:
   {show-header.i}
   
   case selection:
      when "P" then do:
         get prev q-guest.
         if not avail guest then do:
            get first q-guest.
         end.

         run refresh.
      end.
      when "N" then do:
         get next q-guest.
         if not avail guest then do:
            get last q-guest.
         end.

         run refresh.
      end.
      when "F" then do:
         get first q-guest.

         run refresh.
      end.
      when "L" then do:
         get last q-guest.

         run refresh.
      end.
      when "I" then do:
         /* find by name, date of birth */
         def button btn-ok label "Find".
         def button btn-cancel label "Cancel".
         
         form g-f-n skip
              g-l-n skip
              g-dob skip
              btn-ok
              btn-cancel
              with frame f-guest-search side-labels overlay at row 2 col 1 title "Find Guest"
                   cancel-button btn-cancel default-button btn-ok.

         on "choose" of btn-cancel in frame f-guest-search do:
            apply "f4" to frame f-guest-search.
         end.
         on "choose" of btn-ok in frame f-guest-search do:
            apply "go" to frame f-guest-search.
         end.

         G-SEARCH:
         repeat on endkey undo, leave:
            g-f-n = "".
            g-l-n = "".
            g-dob = ?.
            
            update g-f-n g-l-n g-dob btn-ok btn-cancel with frame f-guest-search.
            
            if g-f-n = "" and g-l-n = "" and g-dob = ?
            then do:
               message "Enter at least one search criteria!".
               next g-search.
            end.
      
            find first b-guest 
               where (if g-f-n = ? or g-f-n = "" then true else b-guest.first-name matches g-f-n + "*") and 
                     (if g-l-n = ? or g-l-n = "" then true else b-guest.last-name matches g-l-n + "*") and
                     (if g-dob = ? then true else b-guest.date-of-birth = g-dob) use-index idx-g-id no-lock no-error.

            if avail b-guest then do:
               reposition q-guest to rowid rowid(b-guest).
               get next q-guest.
               run refresh.
            end.
            else do:
               message "No matching record found.".
               next g-search.
            end.
            
            leave.
         end.
         
         hide frame f-guest-search no-pause.
      end.
      when "D" then do:
         if avail guest then do transaction:
            find b-guest where b-guest.guest-id = guest.guest-id exclusive-lock.
            delete b-guest.
            
            get prev q-guest.
         end.

         run refresh.
      end.
      when "A" then do:
         ADD-GUEST:
         do transaction on error undo, leave
                        on endkey undo, leave:
            CREATE-GUEST:
            repeat:
               do on error undo, retry:
                  find last b-guest use-index idx-g-id no-lock no-error.
                  g-id = (if avail b-guest then b-guest.guest-id + 1 else 1).
                  release b-guest.
   
                  create b-guest.
                  assign b-guest.guest-id = g-id.
                  leave CREATE-GUEST.
               end.
            end.
   
            clear frame f-guest all.
            display g-id
                    with frame f-guest.
            
            g-f-n = "".
            g-l-n = "".
            g-dob = ?.
            g-id-type = ?.
            g-id-# = "".
            g-phone-# = "".
            g-street-1 = "".
            g-street-2 = "".
            g-city = "".
            g-state = "".
            g-zip = "".
            g-country = "".

            U-GUEST:
            repeat on error undo add-guest, leave add-guest
                   on endkey undo add-guest, leave add-guest:

               display g-f-n g-l-n g-dob g-phone-# with frame f-guest.
               update g-id-type g-id-# with frame f-guest.
               
               U-GUEST-1:
               repeat on endkey undo u-guest, retry u-guest:

                  display g-street-1 g-street-2 g-city g-state g-zip g-country with frame f-guest.
                  update g-f-n g-l-n g-dob g-phone-# with frame f-guest.
                  
                  U-GUEST-2:
                  repeat on endkey undo u-guest-2, leave u-guest-2:
                     update g-street-1 g-street-2 g-city g-state g-zip g-country with frame f-guest.

                     b-guest.id-type = g-id-type.
                     b-guest.id-number = g-id-#.
                  
                     b-guest.first-name = g-f-n.
                     b-guest.last-name = g-l-n.
                     b-guest.date-of-birth = g-dob.
                     b-guest.phone-number = g-phone-#.

                     b-guest.street-1 = g-street-1.
                     b-guest.street-2 = g-street-2.
                     b-guest.city = g-city.
                     b-guest.state = g-state.
                     b-guest.zip = g-zip.
                     b-guest.country = g-country.
                     
                     leave u-guest.
                  end.
               end.
            end.
         end.

         find guest where guest.guest-id = g-id no-lock no-error.
         reposition q-guest to rowid rowid(guest).
         get next q-guest.
         run refresh.
      end.
      when "U" then do:
         if avail guest then
         U-GUEST:
         repeat transaction on error undo, leave
                            on endkey undo, leave:
            
            find b-guest where b-guest.guest-id = guest.guest-id exclusive-lock.
            g-id-type = b-guest.id-type.
            if g-id-type = ? then g-id-type = 1.
            
            display g-f-n g-l-n g-dob g-phone-# with frame f-guest.
            update g-id-type g-id-# with frame f-guest.
            
            U-GUEST-1:
            repeat on endkey undo u-guest, retry u-guest:

               display g-street-1 g-street-2 g-city g-state g-zip g-country with frame f-guest.
               update g-f-n g-l-n g-dob g-phone-# with frame f-guest.
               
               U-GUEST-2:
               repeat on endkey undo u-guest-2, leave u-guest-2:
                  update g-street-1 g-street-2 g-city g-state g-zip g-country with frame f-guest.
            
                  b-guest.id-type = g-id-type.
                  b-guest.id-number = g-id-#.

                  b-guest.first-name = g-f-n.
                  b-guest.last-name = g-l-n.
                  b-guest.date-of-birth = g-dob.
                  b-guest.phone-number = g-phone-#.

                  b-guest.street-1 = g-street-1.
                  b-guest.street-2 = g-street-2.
                  b-guest.city = g-city.
                  b-guest.state = g-state.
                  b-guest.zip = g-zip.
                  b-guest.country = g-country.
                  
                  leave u-guest.
               end.
            end.
         end.
         
         run refresh.
      end.
      when "R" then do:
         publish "pop-program".
         leave PROC.
      end.
      otherwise do:
         if selection <> ? then do:
            message "Invalid selection - try again".
            selection = ?.
            pause.
            next. 
         end.
      end.
   end.

   {wait-selection.i
      &sele1="(P)rev   (N)ext   (F)irst   (L)ast"
      &sele2="F(i)nd   (A)dd   (U)pdate   (D)elete   "
      }
end.

