{g-vars.i &vsh = "shared"}
{show-header-frame-def.i}

screen-title = "Room Overview".

{show-header.i}

/* view main room screen */

function get-total-rooms returns int(input room-type as int, input f-no as int).
   def var n as int.

   for each room where room.type-of-room = room-type and room.floor = f-no:
      n = n + 1.
   end.

   return n.
end.

def var fheader as char.
def var i as int.
def var j as int.
def var c as int.
def var r as int.
def var hfi as handle.
def var hsl as handle.
def var col-size as int.
def var fsep as char.
def var maxrt as int init 0.

fsep = fill("-", 78).
col-size = 78 / total-floor-no.

do i = 1 to total-floor-no:
   fheader = fheader + "Floor " + string(i) + fill(" ", col-size - length("floor n")).
end.

do i = 1 to extent(room-types):
   maxrt = max(maxrt, length(room-types[i])).
end.

form fheader view-as text format "x(78)" skip
     fsep view-as text format "x(78)" skip
     with frame f-room-overview no-labels size 80 by 20 at row 2 col 1.

display fheader fsep with frame f-room-overview.

create widget-pool.
do i = 1 to total-floor-no:
   c = (i - 1) * col-size + 1.
   
   do j = 1 to extent(room-types):
      r = j + 2.
      
      create text hfi.
      hfi:frame = frame f-room-overview:handle.
      hfi:row = r.
      hfi:col = c + maxrt + 4.
      hfi:data-type = "integer".
      hfi:format = ">>>".
      hfi:visible = true.
      hfi:screen-value = string(get-total-rooms(j, i)).
      
      create text hsl.
      hsl:row = r.
      hsl:col = c.
      hsl:frame = frame f-room-overview:handle.
      hsl:format = "x(" + string(maxrt) + ")".
      hsl:screen-value = room-types[j].
      hsl:visible = true.

      hfi:side-label-handle = hsl.
   end.
end.

def var selection as char.
selection = ?.

PROC:
repeat:
   
   case selection:
      when "R" then leave PROC.
      otherwise do:
         if selection <> ? then do:
            message "Invalid selection - try again".
            selection = ?.
            pause.
            next PROC.
         end. 
      end.
   end.
   
   {wait-selection.i}
end.

publish "pop-program".

