
    create table checkout (
        id int8 not null,
        reservation_id int4,
        room_charges numeric(50,2),
        sales_tax numeric(50,2),
        total numeric(50,2),
        state text,
        primary key (id)
    );

    create table checkout_rooms (
        id int8 not null,
        reservation_id int4,
        minibar_charges numeric(50,2),
        laundry_charges numeric(50,2),
        room_charges numeric(50,2),
        room_number int4 not null,
        primary key (id)
    );

    create table checkout_rooms__4 (
        parent__id int8 not null,
        guest_ids int4,
        list__index int4 not null,
        primary key (parent__id, list__index)
    );

    create table guest (
        id int8 not null,
        guest_id int4,
        first_name text,
        last_name text,
        id_type int4,
        id_number text,
        date_of_birth date,
        phone_number text,
        country text,
        city text,
        street_2 text,
        street_1 text,
        state text,
        zip text,
        primary key (id)
    );

    create table meta_user (
        id int8 not null,
        userid text not null,
        password text not null,
        user_name text,
        user_misc text,
        user_number int4,
        group_number int4,
        given_name text,
        middle_initial text,
        surname text,
        telephone text,
        email text,
        description text,
        disabled bool,
        create_date_timestamp timestamp,
        create_date_offset int4,
        account_expires_timestamp timestamp,
        account_expires_offset int4,
        pwd_expires_timestamp timestamp,
        pwd_expires_offset int4,
        pwd_duration int4,
        last_login_timestamp timestamp,
        last_login_offset int4,
        logins int4,
        max_logins int4,
        max_tries int4,
        login_failures int4,
        spare1 int4,
        spare2 int4,
        spare3 text,
        spare4 text,
        primary key (id)
    );

    create table meta_user__8 (
        parent__id int8 not null,
        u_misc1 int4,
        u_misc2 text,
        list__index int4 not null,
        primary key (parent__id, list__index)
    );

    create table rate (
        id int8 not null,
        type_of_room int4 not null,
        floor int4 not null,
        rate numeric(50,2) not null,
        start_date date,
        end_date date,
        primary key (id)
    );

    create table reservation (
        id int8 not null,
        reservation_id int4 not null,
        discount numeric(50,2),
        datevalue date,
        checkin date,
        checkout date,
        guest_id int4,
        details text,
        state text,
        primary key (id)
    );

    create table reservation_rooms (
        id int8 not null,
        reservation_id int4,
        type_of_room int4 not null,
        rooms int4,
        primary key (id)
    );

    create table room (
        id int8 not null,
        type_of_room int4 not null,
        room_number int4 not null,
        floor int4 not null,
        primary key (id)
    );

    create table room_state (
        id int8 not null,
        room_number int4 not null,
        state bool not null,
        start_date date,
        primary key (id)
    );

    create index checkout_rooms__4_fkey on checkout_rooms__4 (parent__id);

    alter table checkout_rooms__4 
        add constraint FK60FEC535E5588870 
        foreign key (parent__id) 
        references checkout_rooms;

    create index meta_user__8_fkey on meta_user__8 (parent__id);

    alter table meta_user__8 
        add constraint FK67DDD4733D1B017C 
        foreign key (parent__id) 
        references meta_user;
