package com.goldencode.hotel;

import com.goldencode.p2j.util.*;
import com.goldencode.p2j.ui.*;

import static com.goldencode.p2j.util.BlockManager.*;
import static com.goldencode.p2j.util.MathOps.*;
import static com.goldencode.p2j.util.CompareOps.*;
import static com.goldencode.p2j.util.TextOps.*;
import static com.goldencode.p2j.util.ProcedureManager.*;
import static com.goldencode.p2j.util.KeyReader.*;
import static com.goldencode.p2j.ui.LogicalTerminal.*;
import static com.goldencode.p2j.util.character.*;

/**
 * Business logic (converted to Java from the 4GL source code
 * in exit.p).
 */
public class Exit
{
   logical progStarted = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "progStarted", new logical(false));

   character uName = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "uName", new character(""));

   /**
    * External procedure (converted to Java from the 4GL source code
    * in exit.p).
    */
   public void execute()
   {
      integer timer = UndoableFactory.integer();
      
      externalProcedure(Exit.this, new Block((Body) () -> 
      {
         progStarted.assign(true);
         putScreen("Do you want to quit?", plus(getScreenLines(), 1), 1, new ColorSpec(ColorSpec.COLOR_MESSAGES));
         putScreen("NO", plus(getScreenLines(), 1), 22, new ColorSpec("underline"));
         bell();
         timer.assign(60);
         
         pTimer:
         while (_isGreaterThanOrEqual(timer, 0))
         {
            KeyReader.readKey(1);
            putScreen(concat("Auto-logout in ", valueOf(timer), " seconds."), plus(getScreenLines(), 2), 1, new ColorSpec(ColorSpec.COLOR_NORMAL));
            timer.assign(minus(timer, 1));
            
            if (_isNotEqual(lastKey(), -1))
            {
               if (_isEqual(toUpperCase(keyFunction(lastKey())), "Y"))
               {
                  NamedEventManager.publish("pop-program", thisProcedure());
                  break pTimer;
               }
               else
               {
                  NamedEventManager.publish("pop-program", thisProcedure());
                  returnNormal();
               }
            }
         }
         
         quit();
      }));
   }
}
