package com.goldencode.hotel;

import com.goldencode.p2j.util.*;
import com.goldencode.hotel.ui.*;
import com.goldencode.p2j.ui.*;

import static com.goldencode.p2j.util.BlockManager.*;
import static com.goldencode.p2j.util.MathOps.*;
import static com.goldencode.p2j.util.CompareOps.*;
import static com.goldencode.p2j.util.logical.*;
import static com.goldencode.p2j.util.TextOps.*;
import static com.goldencode.p2j.util.ProcedureManager.*;
import static com.goldencode.p2j.ui.LogicalTerminal.*;
import static com.goldencode.p2j.util.ArrayAssigner.*;
import static com.goldencode.p2j.util.character.*;

/**
 * Business logic (converted to Java from the 4GL source code
 * in menu.p).
 */
public class Menu
{
   MenuFMainHeader fMainHeaderFrame = GenericFrame.createFrame(MenuFMainHeader.class, "f-main-header");

   MenuFMenu fMenuFrame = GenericFrame.createFrame(MenuFMenu.class, "f-menu");

   logical progStarted = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "progStarted", new logical(false));

   character uName = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "uName", new character(""));

   character screenTitle = SharedVariableManager.lookupVariable("screenTitle", character.class);

   /**
    * External procedure (converted to Java from the 4GL source code
    * in menu.p).
    */
   public void execute()
   {
      character hTime = UndoableFactory.character();
      character[] menuItems = UndoableFactory.characterExtent(6);
      character[] progs = UndoableFactory.characterExtent(6);
      
      externalProcedure(Menu.this, new Block((Body) () -> 
      {
         fMainHeaderFrame.openScope();
         fMenuFrame.openScope();
         progStarted.assign(true);
         screenTitle.assign("Menu");
         
         if (_or(isUnknown(uName), () -> isEqual(uName, "")))
         {
            messageBox("You are not logged in - access denied", ALERT_MESSAGE, BTN_OK, (String) null);
            quit();
         }
         
         hTime.assign(valueOf(datetimetz.now(), "99/99/99 HH:MM:SS"));
         hTime.assign(substring(hTime, 10));
         
         doBlock("blockLabel0", new Block((Body) () -> 
         {
            fMainHeaderFrame.widgetUName().setColumn(new decimal(new integer(1)));
            fMainHeaderFrame.widgetScreenTitle().setColumn(plus(plus(fMainHeaderFrame.widgetUName().getColumn(), length(uName)), divide(minus(minus(minus(fMainHeaderFrame.getWidthChars(), length(uName)), length(screenTitle)), length(hTime)), 2)));
            fMainHeaderFrame.widgetHTime().setColumn(minus(fMainHeaderFrame.getWidthChars(), length(hTime)));
            fMainHeaderFrame.widgetScreenTitle().setFormat(concat("x(", valueOf(length(screenTitle)), ")"));
         }));
         
         FrameElement[] elementList0 = new FrameElement[]
         {
            new Element(uName, fMainHeaderFrame.widgetUName()),
            new Element(screenTitle, fMainHeaderFrame.widgetScreenTitle()),
            new Element(hTime, fMainHeaderFrame.widgetHTime())
         };
         
         fMainHeaderFrame.display(elementList0);
         
         assignSingle(menuItems, 1, "R Rooms");
         assignSingle(menuItems, 2, "T Rates");
         assignSingle(menuItems, 3, "G Guests");
         assignSingle(menuItems, 4, "S Reservations");
         assignSingle(menuItems, 5, "K Check out");
         assignSingle(menuItems, 6, "X Exit");
         assignSingle(progs, 1, "rooms.p");
         assignSingle(progs, 2, "rates.p");
         assignSingle(progs, 3, "guests.p");
         assignSingle(progs, 4, "reservations.p");
         assignSingle(progs, 5, "checkout.p");
         assignSingle(progs, 6, "exit.p");
         
         FrameElement[] elementList1 = new FrameElement[]
         {
            new Element(subscript(menuItems, 1), fMenuFrame.widgetMenuItemsArray0()),
            new Element(subscript(menuItems, 2), fMenuFrame.widgetMenuItemsArray1()),
            new Element(subscript(menuItems, 3), fMenuFrame.widgetMenuItemsArray2()),
            new Element(subscript(menuItems, 4), fMenuFrame.widgetMenuItemsArray3()),
            new Element(subscript(menuItems, 5), fMenuFrame.widgetMenuItemsArray4()),
            new Element(subscript(menuItems, 6), fMenuFrame.widgetMenuItemsArray5())
         };
         
         fMenuFrame.display(elementList1);
         
         registerTrigger(new EventList(new String[]
         {
            "R",
            "r"
         }, true), Menu.this, new Trigger((Body) () -> 
         {
            NamedEventManager.publish("push-program", thisProcedure(), "I", new Object[]
            {
               "rooms.p"
            });
            stop();
         }));
         
         registerTrigger(new EventList(new String[]
         {
            "T",
            "t"
         }, fMenuFrame.asWidget()), Menu.this, new Trigger((Body) () -> 
         {
            NamedEventManager.publish("push-program", thisProcedure(), "I", new Object[]
            {
               "rates.p"
            });
            stop();
         }));
         
         registerTrigger(new EventList(new String[]
         {
            "G",
            "g"
         }, fMenuFrame.asWidget()), Menu.this, new Trigger((Body) () -> 
         {
            NamedEventManager.publish("push-program", thisProcedure(), "I", new Object[]
            {
               "guests.p"
            });
            stop();
         }));
         
         registerTrigger(new EventList(new String[]
         {
            "S",
            "s"
         }, fMenuFrame.asWidget()), Menu.this, new Trigger((Body) () -> 
         {
            NamedEventManager.publish("push-program", thisProcedure(), "I", new Object[]
            {
               "reservations.p"
            });
            stop();
         }));
         
         registerTrigger(new EventList(new String[]
         {
            "K",
            "k"
         }, fMenuFrame.asWidget()), Menu.this, new Trigger((Body) () -> 
         {
            NamedEventManager.publish("push-program", thisProcedure(), "I", new Object[]
            {
               "checkout.p"
            });
            stop();
         }));
         
         registerTrigger(new EventList(new String[]
         {
            "X",
            "x"
         }, true), Menu.this, new Trigger((Body) () -> 
         {
            NamedEventManager.publish("push-program", thisProcedure(), "I", new Object[]
            {
               "exit.p"
            });
            stop();
         }));
         
         OnPhrase[] onPhrase0 = new OnPhrase[]
         {
            new OnPhrase(Condition.ERROR, Action.LEAVE, "proc"),
            new OnPhrase(Condition.STOP, Action.LEAVE, "proc"),
            new OnPhrase(Condition.ENDKEY, Action.LEAVE, "proc")
         };
         
         repeat("proc", onPhrase0, new Block((Body) () -> 
         {
            Choose choose0 = new Choose();
            choose0.addField(fMenuFrame.widgetMenuItemsArray0(), "Select an option");
            choose0.addField(fMenuFrame.widgetMenuItemsArray1(), "Select an option");
            choose0.addField(fMenuFrame.widgetMenuItemsArray2(), "Select an option");
            choose0.addField(fMenuFrame.widgetMenuItemsArray3(), "Select an option");
            choose0.addField(fMenuFrame.widgetMenuItemsArray4(), "Select an option");
            choose0.addField(fMenuFrame.widgetMenuItemsArray5(), "Select an option");
            choose0.addGoOn("f5");
            choose0.setAutoReturn();
            
            fMenuFrame.choose(choose0);
            
            if (_isUnknown(getFrameIndex()))
            {
               messageBox("No option selected.", ALERT_MESSAGE, BTN_OK, (String) null);
            }
            else
            {
               NamedEventManager.publish("push-program", thisProcedure(), "I", new Object[]
               {
                  subscript(progs, getFrameIndex())
               });
               leave("proc");
            }
         }));
      }));
   }
}
