package com.goldencode.hotel;

import com.goldencode.p2j.util.*;
import com.goldencode.hotel.ui.*;
import com.goldencode.p2j.ui.*;
import com.goldencode.p2j.persist.*;
import com.goldencode.hotel.dmo._temp.*;
import com.goldencode.hotel.dmo.hotel.*;
import com.goldencode.p2j.persist.lock.*;
import java.util.function.*;

import static com.goldencode.p2j.util.BlockManager.*;
import static com.goldencode.p2j.util.MathOps.*;
import static com.goldencode.p2j.util.CompareOps.*;
import static com.goldencode.p2j.util.logical.*;
import static com.goldencode.p2j.util.TextOps.*;
import static com.goldencode.p2j.util.ProcedureManager.*;
import static com.goldencode.p2j.util.ArrayAssigner.*;
import static com.goldencode.p2j.util.character.*;
import static com.goldencode.p2j.ui.LogicalTerminal.*;

/**
 * Business logic (converted to Java from the 4GL source code
 * in rates.p).
 */
public class Rates
{
   public static final String FMT_STR_1 = "->>,>>9.99";

   public static final String FMT_STR_2 = "99/99/99";

   public static final String FMT_STR_3 = "9";

   TRoomType1_1.Buf tRoomType = SharedVariableManager.addTempTable("tRoomType", TRoomType1_1.Buf.class, "tRoomType", "t-room-type");

   TFloor1_1.Buf tFloor = SharedVariableManager.addTempTable("tFloor", TFloor1_1.Buf.class, "tFloor", "t-floor");

   Rate.Buf bRate = RecordBuffer.define(Rate.Buf.class, "hotel", "bRate", "b-rate");

   Rate.Buf bRate2 = RecordBuffer.define(Rate.Buf.class, "hotel", "bRate2", "b-rate2");

   Rate.Buf rate = RecordBuffer.define(Rate.Buf.class, "hotel", "rate", "rate");

   RatesFURate fURateFrame = GenericFrame.createFrame(RatesFURate.class, "f-u-rate");

   RatesFMainHeader fMainHeaderFrame = GenericFrame.createFrame(RatesFMainHeader.class, "f-main-header");

   RatesFRates fRatesFrame = GenericFrame.createFrame(RatesFRates.class, "f-rates");

   logical progStarted = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "progStarted", new logical(false));

   character uName = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "uName", new character(""));

   character screenTitle = SharedVariableManager.lookupVariable("screenTitle", character.class);

   integer totalFloorNo = SharedVariableManager.lookupVariable("totalFloorNo", integer.class);

   character[] roomTypes = SharedVariableManager.lookupVariable("roomTypes", character.class, 5);

   character hTime = UndoableFactory.character();

   integer currentFloorNo = SharedVariableManager.addVariable("currentFloorNo", new integer(1));

   integer currentRoomType = SharedVariableManager.addVariable("currentRoomType", new integer());

   logical popProg = UndoableFactory.logical(true);

   decimal rRate = UndoableFactory.decimal(new decimal(0));

   date rSDate = UndoableFactory.date();

   date rEDate = UndoableFactory.date();

   final QueryWrapper query0 = new QueryWrapper("q-room", true);

   RatesTrigger1FCopy trigger1FCopyFrame = null;

   integer fFrom = UndoableFactory.integer();

   integer fTo = UndoableFactory.integer();

   RatesTrigger2FFloorNo trigger2FFloorNoFrame = null;

   integer floorNo = UndoableFactory.integer();

   RatesTrigger3FRoomType trigger3FRoomTypeFrame = null;

   /**
    * External procedure (converted to Java from the 4GL source code
    * in rates.p).
    */
   public void execute()
   {
      integer i = UndoableFactory.integer();
      
      externalProcedure(Rates.this, new Block((Init) () -> 
      {
         rRate.setPrecision(2);
      }, 
      (Body) () -> 
      {
         query0.addBuffer(tFloor, true);
         query0.addBuffer(tRoomType, true);
         query0.addBuffer(rate, true);
         fURateFrame.widgetREDate().setValidation(((ValidationExpr<date>) (date rEDate_) -> and(notUnknown(rEDate_), () -> isGreaterThanOrEqual(rEDate_, fURateFrame.widgetRSDate().inputValue()))), "End date must be after start date!");
         fMainHeaderFrame.openScope();
         fURateFrame.openScope();
         fRatesFrame.openScope();
         RecordBuffer.openScope(bRate, tFloor, tRoomType, rate);
         progStarted.assign(true);
         screenTitle.assign("Room Rates");
         
         ToClause toClause0 = new ToClause(i, 1, totalFloorNo);
         
         doTo(TransactionType.FULL, "loopLabel0", toClause0, new Block((Body) () -> 
         {
            tFloor.create();
            tFloor.setFloor(i);
         }));
         
         ToClause toClause1 = new ToClause(i, 1, roomTypes.length);
         
         doTo(TransactionType.FULL, "loopLabel1", toClause1, new Block((Body) () -> 
         {
            tRoomType.create();
            tRoomType.setType(i);
            tRoomType.setName(subscript(roomTypes, i));
         }));
         
         FrameElement[] elementList0 = new FrameElement[]
         {
            new Element(new FieldReference(tFloor, "floor"), fRatesFrame.widgetBrwsFloorColumn()),
            new Element(new FieldReference(tRoomType, "name"), fRatesFrame.widgetBrwsNameColumn()),
            new Element(new FieldReference(rate, "startDate"), fRatesFrame.widgetBrwsStartDateColumn()),
            new Element(new FieldReference(rate, "endDate"), fRatesFrame.widgetBrwsEndDateColumn()),
            new Element(new FieldReference(rate, "rate"), fRatesFrame.widgetBrwsRateColumn())
         };
         fRatesFrame.widgetBrws().registerQuery(query0, elementList0);
         
         registerTrigger(new EventList(new String[]
         {
            "y",
            "Y"
         }, true), Rates.this, new Trigger((Pre) () -> 
         {
            trigger1FCopyFrame = GenericFrame.createFrame(RatesTrigger1FCopy.class, "trigger1-f-copy");
         }, 
         (Body) () -> 
         {
            trigger1FCopyFrame.widgetFTo().setValidation(((ValidationExpr<integer>) (integer fTo_) -> isNotEqual(fTo_, fFrom)), "Floors must be different!");
            trigger1FCopyFrame.openScope();
            fFrom.assign(currentFloorNo);
            fTo.assign(1);
            
            OnPhrase[] onPhrase0 = new OnPhrase[]
            {
               new OnPhrase(Condition.ENDKEY, Action.LEAVE, "loopLabel2"),
               new OnPhrase(Condition.ERROR, Action.LEAVE, "loopLabel2")
            };
            
            repeat(TransactionType.FULL, "loopLabel2", onPhrase0, new Block((Body) () -> 
            {
               FrameElement[] elementList3 = new FrameElement[]
               {
                  new Element(fFrom, trigger1FCopyFrame.widgetFFrom()),
                  new Element(fTo, trigger1FCopyFrame.widgetFTo())
               };
               
               trigger1FCopyFrame.update(elementList3);
               
               if (_or(or(or(isUnknown(fFrom), () -> isUnknown(fTo)), () -> not(and(isGreaterThanOrEqual(fFrom, 1), () -> isLessThanOrEqual(fFrom, totalFloorNo)))), () -> not(and(isGreaterThanOrEqual(fTo, 1), () -> isLessThanOrEqual(fTo, totalFloorNo)))))
               {
                  undoNext("loopLabel2");
               }
               
               PreselectQuery query1 = new PreselectQuery();
               
               forEach(TransactionType.FULL, "loopLabel3", new Block((Init) () -> 
               {
                  query1.initialize(bRate, "bRate.floor = ?", null, "bRate.startDate asc", new Object[]
                  {
                     fTo
                  });
               }, 
               (Body) () -> 
               {
                  query1.next();
                  bRate.deleteRecord();
               }));
               
               AdaptiveQuery query2 = new AdaptiveQuery();
               
               forEach(TransactionType.FULL, "loopLabel4", new Block((Init) () -> 
               {
                  RecordBuffer.openScope(bRate, bRate2);
                  query2.initialize(bRate, "bRate.floor = ?", null, "bRate.startDate asc", new Object[]
                  {
                     fFrom
                  });
               }, 
               (Body) () -> 
               {
                  query2.next();
                  bRate2.create();
                  RecordBuffer.copy(bRate, bRate2, true);
                  bRate2.setFloor(fTo);
               }));
               
               messageBox(new Object[]
               {
                  "Copied all rates from floor",
                  fFrom,
                  "to floor",
                  fTo
               }, ALERT_MESSAGE, BTN_OK, (String) null);
               leave("loopLabel2");
            }));
            
            trigger1FCopyFrame.hide(true);
            
            ControlFlowOps.invoke("refresh");
         }));
         
         registerTrigger(new EventList(new String[]
         {
            "a",
            "A"
         }, true), Rates.this, new Trigger((Body) () -> 
         {
            OnPhrase[] onPhrase1 = new OnPhrase[]
            {
               new OnPhrase(Condition.ENDKEY, Action.LEAVE, "blockLabel1")
            };
            
            doBlock(TransactionType.FULL, "blockLabel1", onPhrase1, new Block((Body) () -> 
            {
               ErrorManager.silentErrorEnable();
               /* find last rate after which to add */
               new FindQuery(bRate, "bRate.floor = ? and bRate.typeOfRoom = ?", null, "bRate.startDate asc", new Object[]
               {
                  rate.getFloor(),
                  rate.getTypeOfRoom()
               }, LockType.NONE).last();
               ErrorManager.silentErrorDisable();
               
               if (bRate._available())
               {
                  rRate.assign(bRate.getRate());
                  rSDate.assign(date.plusDays(bRate.getEndDate(), 1));
                  rEDate.setUnknown();
                  
                  FrameElement[] elementList4 = new FrameElement[]
                  {
                     new Element(new FieldReference(tFloor, "floor"), fURateFrame.widgetFloor()),
                     new Element(new FieldReference(tRoomType, "name"), fURateFrame.widgetName()),
                     new Element(rSDate, fURateFrame.widgetRSDate()),
                     new Element(rEDate, fURateFrame.widgetREDate()),
                     new Element(rRate, fURateFrame.widgetRRate())
                  };
                  
                  fURateFrame.display(elementList4);
                  
                  FrameElement[] elementList5 = new FrameElement[]
                  {
                     new Element(rEDate, fURateFrame.widgetREDate()),
                     new Element(rRate, fURateFrame.widgetRRate())
                  };
                  
                  fURateFrame.update(elementList5);
               }
               else
               {
                  rSDate.assign(date.today());
                  rRate.assign(0);
                  
                  FrameElement[] elementList6 = new FrameElement[]
                  {
                     new Element(new FieldReference(tFloor, "floor"), fURateFrame.widgetFloor()),
                     new Element(new FieldReference(tRoomType, "name"), fURateFrame.widgetName()),
                     new Element(rSDate, fURateFrame.widgetRSDate()),
                     new Element(rEDate, fURateFrame.widgetREDate()),
                     new Element(rRate, fURateFrame.widgetRRate())
                  };
                  
                  fURateFrame.display(elementList6);
                  
                  FrameElement[] elementList7 = new FrameElement[]
                  {
                     new Element(rSDate, fURateFrame.widgetRSDate()),
                     new Element(rEDate, fURateFrame.widgetREDate()),
                     new Element(rRate, fURateFrame.widgetRRate())
                  };
                  
                  fURateFrame.update(elementList7);
               }
               
               bRate.create();
               bRate.setFloor(tFloor.getFloor());
               bRate.setTypeOfRoom(tRoomType.getType());
               bRate.setRate(rRate);
               bRate.setStartDate(rSDate);
               bRate.setEndDate(rEDate);
               bRate.release();
            }));
            
            ControlFlowOps.invoke("refresh");
         }));
         
         registerTrigger(new EventList(new String[]
         {
            "c",
            "C"
         }, true), Rates.this, new Trigger((Body) () -> 
         {
            if (_not(rate.available()))
            {
               messageBox("Add a rate for this floor and room-type before changing!", ALERT_MESSAGE, BTN_OK, (String) null);
               ControlFlowOps.invoke("refresh");
               returnNormal();
            }
            
            if (_isLessThan(rate.getEndDate(), date.today()))
            {
               message("Can not modify a rate in the past!");
               ControlFlowOps.invoke("refresh");
               returnNormal();
            }
            
            OnPhrase[] onPhrase2 = new OnPhrase[]
            {
               new OnPhrase(Condition.ENDKEY, Action.LEAVE, "blockLabel2")
            };
            
            doBlock(TransactionType.FULL, "blockLabel2", onPhrase2, new Block((Body) () -> 
            {
               rSDate.assign((_isGreaterThanOrEqual(rate.getStartDate(), date.today()) ? rate.getStartDate() : date.today()));
               rEDate.assign(rate.getEndDate());
               rRate.assign(rate.getRate());
               
               FrameElement[] elementList8 = new FrameElement[]
               {
                  new Element(new FieldReference(tFloor, "floor"), fURateFrame.widgetFloor()),
                  new Element(new FieldReference(tRoomType, "name"), fURateFrame.widgetName()),
                  new Element(rSDate, fURateFrame.widgetRSDate()),
                  new Element(rEDate, fURateFrame.widgetREDate()),
                  new Element(rRate, fURateFrame.widgetRRate())
               };
               
               fURateFrame.display(elementList8);
               
               FrameElement[] elementList9 = new FrameElement[]
               {
                  new Element(rRate, fURateFrame.widgetRRate())
               };
               
               fURateFrame.update(elementList9);
               
               /* check if rate changed */
               if (_isEqual(rRate, rate.getRate()))
               {
                  ControlFlowOps.invoke("refresh");
                  returnNormal();
               }
               
               new FindQuery(bRate, "bRate.id = ?", null, "bRate.startDate asc", new Object[]
               {
                  (P2JQuery.Parameter) () -> rate.recordID()
               }, LockType.EXCLUSIVE).unique();
               
               if (_isGreaterThanOrEqual(rate.getStartDate(), date.today()))
               {
                  bRate.setRate(rRate);
               }
               else
               {
                  bRate.setEndDate(date.minusDays(rSDate, 1));
                  bRate.create();
                  bRate.setFloor(rate.getFloor());
                  bRate.setTypeOfRoom(rate.getTypeOfRoom());
                  bRate.setRate(rRate);
                  bRate.setStartDate(rSDate);
                  bRate.setEndDate(rEDate);
               }
               
               bRate.release();
            }));
            
            ControlFlowOps.invoke("refresh");
         }));
         
         registerTrigger(new EventList(new String[]
         {
            "s",
            "S"
         }, true), Rates.this, new Trigger((Pre) () -> 
         {
            trigger2FFloorNoFrame = GenericFrame.createFrame(RatesTrigger2FFloorNo.class, "trigger2-f-floor-no");
         }, 
         (Body) () -> 
         {
            trigger2FFloorNoFrame.widgetFloorNo().setValidation(((ValidationExpr<integer>) (integer floorNo_) -> and(isGreaterThanOrEqual(floorNo_, 1), () -> isLessThanOrEqual(floorNo_, totalFloorNo))), ((ValidationMsg<integer>) (integer floorNo_) -> concat("Floor number must be between 1 and ", valueOf(totalFloorNo))));
            trigger2FFloorNoFrame.openScope();
            
            OnPhrase[] onPhrase3 = new OnPhrase[]
            {
               new OnPhrase(Condition.ENDKEY, Action.LEAVE, "blockLabel3")
            };
            
            doBlock(TransactionType.SUB, "blockLabel3", onPhrase3, new Block((Body) () -> 
            {
               floorNo.assign(currentFloorNo);
               
               FrameElement[] elementList10 = new FrameElement[]
               {
                  new Element(floorNo, trigger2FFloorNoFrame.widgetFloorNo())
               };
               
               trigger2FFloorNoFrame.update(elementList10);
               
               trigger2FFloorNoFrame.hide(true);
               
               currentFloorNo.assign(floorNo);
            }));
            
            ControlFlowOps.invoke("refresh");
         }));
         
         registerTrigger(new EventList(new String[]
         {
            "t",
            "T"
         }, true), TriggerBlock0.class, Rates.this);
         
         registerTrigger(new EventList(new String[]
         {
            "o",
            "O"
         }, true), Rates.this, new Trigger((Body) () -> 
         {
            NamedEventManager.publish("push-program", thisProcedure(), "I", new Object[]
            {
               "rates-report.p"
            });
            popProg.assign(false);
            fRatesFrame.apply("r");
         }));
         
         ControlFlowOps.invoke("refresh");
         
         FrameElement[] elementList12 = new FrameElement[]
         {
            new WidgetElement(fRatesFrame.widgetBrws())
         };
         
         fRatesFrame.enable(elementList12);
         
         OnPhrase[] onPhrase5 = new OnPhrase[]
         {
            new OnPhrase(Condition.ENDKEY, Action.LEAVE, "blockLabel5")
         };
         
         doBlock(TransactionType.SUB, "blockLabel5", onPhrase5, new Block((Body) () -> 
         {
            LogicalTerminal.waitFor(fRatesFrame, new EventList(new String[]
            {
               "r",
               "R"
            }, fRatesFrame.asWidget()));
         }));
         
         if ((popProg).booleanValue())
         {
            NamedEventManager.publish("pop-program", thisProcedure());
         }
      }));
   }

   public void refresh()
   {
      internalProcedure(new Block((Body) () -> 
      {
         if (_or(isUnknown(uName), () -> isEqual(uName, "")))
         {
            messageBox("You are not logged in - access denied", ALERT_MESSAGE, BTN_OK, (String) null);
            quit();
         }
         
         hTime.assign(valueOf(datetimetz.now(), "99/99/99 HH:MM:SS"));
         hTime.assign(substring(hTime, 10));
         
         doBlock("blockLabel0", new Block((Body) () -> 
         {
            fMainHeaderFrame.widgetUName().setColumn(new decimal(new integer(1)));
            fMainHeaderFrame.widgetScreenTitle().setColumn(plus(plus(fMainHeaderFrame.widgetUName().getColumn(), length(uName)), divide(minus(minus(minus(fMainHeaderFrame.getWidthChars(), length(uName)), length(screenTitle)), length(hTime)), 2)));
            fMainHeaderFrame.widgetHTime().setColumn(minus(fMainHeaderFrame.getWidthChars(), length(hTime)));
            fMainHeaderFrame.widgetScreenTitle().setFormat(concat("x(", valueOf(length(screenTitle)), ")"));
         }));
         
         FrameElement[] elementList1 = new FrameElement[]
         {
            new Element(uName, fMainHeaderFrame.widgetUName()),
            new Element(screenTitle, fMainHeaderFrame.widgetScreenTitle()),
            new Element(hTime, fMainHeaderFrame.widgetHTime())
         };
         
         fMainHeaderFrame.display(elementList1);
         
         fRatesFrame.widgetBrws().setTitle(concat((_isUnknown(currentFloorNo) ? new character("All Floors") : concat("Floor ", valueOf(currentFloorNo))), " - ", (_isUnknown(currentRoomType) ? new character("All Room Types") : subscript(roomTypes, currentRoomType))));
         query0.assign(new CompoundQuery().initialize(true, false));
         query0.addComponent(new AdaptiveQuery().initialize(tFloor, "case when ? then true else tFloor.floor = ? end", null, "tFloor.id asc", new Object[]
         {
            isUnknown(currentFloorNo),
            currentFloorNo
         }));
         query0.addComponent(new AdaptiveQuery().initialize(tRoomType, "case when ? then true else tRoomType.type = ? end", null, "tRoomType.id asc", new Object[]
         {
            isUnknown(currentRoomType),
            currentRoomType
         }));
         query0.addComponent(new AdaptiveQuery().initialize(rate, "rate.floor = ? and rate.typeOfRoom = ?", null, "rate.endDate asc", new Object[]
         {
            new FieldReference(tFloor, "floor"),
            new FieldReference(tRoomType, "type")
         }), QueryConstants.NEXT, true);
         query0.open();
         
         FrameElement[] elementList2 = new FrameElement[]
         {
            new WidgetElement(fRatesFrame.widgetBrws())
         };
         
         /*
            def var q-row as int.
            q-row = current-result-row(query q-room).
         
            reposition q-room row q-row.
         */
         fRatesFrame.display(elementList2);
         
         fRatesFrame.widgetBrws().refresh();
         
         hideMessage(true);
         
         message("(A)dd   (C)hange   (S)et Floor   Set Room (T)ype");
         message("Cop(Y) to Floor   (O)utput   (R)eturn");
      }));
   }

   public class TriggerBlock0
   extends Trigger
   {
      integer rType = UndoableFactory.integer();

      public void pre()
      {
         trigger3FRoomTypeFrame = GenericFrame.createFrame(RatesTrigger3FRoomType.class, "trigger3-f-room-type");
      }

      public void body()
      {
         trigger3FRoomTypeFrame.openScope();
         
         OnPhrase[] onPhrase4 = new OnPhrase[]
         {
            new OnPhrase(Condition.ENDKEY, Action.LEAVE, "blockLabel4")
         };
         
         doBlock(TransactionType.SUB, "blockLabel4", onPhrase4, new Block((Body) () -> 
         {
            rType.assign(currentRoomType);
            ControlFlowOps.invokeWithMode("set-room-types-combo", "I", trigger3FRoomTypeFrame.widgetRType().asWidgetHandle());
            
            FrameElement[] elementList11 = new FrameElement[]
            {
               new Element(rType, trigger3FRoomTypeFrame.widgetRType())
            };
            
            trigger3FRoomTypeFrame.update(elementList11);
            
            trigger3FRoomTypeFrame.hide(true);
            
            currentRoomType.assign(rType);
         }));
         
         currentFloorNo.setUnknown();
         ControlFlowOps.invoke("refresh");
      }
   }
}
