package com.goldencode.hotel;

import com.goldencode.p2j.util.*;
import com.goldencode.hotel.ui.*;
import com.goldencode.p2j.ui.*;
import com.goldencode.p2j.persist.*;
import com.goldencode.hotel.dmo.hotel.*;
import com.goldencode.util.*;
import com.goldencode.p2j.persist.lock.*;
import java.util.function.*;

import static com.goldencode.p2j.util.BlockManager.*;
import static com.goldencode.p2j.util.MathOps.*;
import static com.goldencode.p2j.util.CompareOps.*;
import static com.goldencode.p2j.util.logical.*;
import static com.goldencode.p2j.util.TextOps.*;
import static com.goldencode.p2j.util.ProcedureManager.*;
import static com.goldencode.p2j.util.character.*;
import static com.goldencode.p2j.ui.LogicalTerminal.*;

/**
 * Business logic (converted to Java from the 4GL source code
 * in rooms.p).
 */
public class Rooms
{
   public static final String FMT_STR_1 = ">>9";

   public static final String FMT_STR_2 = "Active/Inactive";

   public static final String FMT_STR_3 = "99/99/99";

   Room.Buf bRoom2 = RecordBuffer.define(Room.Buf.class, "hotel", "bRoom2", "b-room2");

   RoomState.Buf bRoomState2 = RecordBuffer.define(RoomState.Buf.class, "hotel", "bRoomState2", "b-room-state2");

   RoomState.Buf roomState = RecordBuffer.define(RoomState.Buf.class, "hotel", "roomState", "room-state");

   Room.Buf room = RecordBuffer.define(Room.Buf.class, "hotel", "room", "room");

   RoomsFFloorNo fFloorNoFrame = GenericFrame.createFrame(RoomsFFloorNo.class, "f-floor-no");

   RoomsFFind fFindFrame = GenericFrame.createFrame(RoomsFFind.class, "f-find");

   RoomsFMainHeader fMainHeaderFrame = GenericFrame.createFrame(RoomsFMainHeader.class, "f-main-header");

   RoomsFRoom fRoomFrame = GenericFrame.createFrame(RoomsFRoom.class, "f-room");

   logical progStarted = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "progStarted", new logical(false));

   character uName = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "uName", new character(""));

   character screenTitle = SharedVariableManager.lookupVariable("screenTitle", character.class);

   integer totalFloorNo = SharedVariableManager.lookupVariable("totalFloorNo", integer.class);

   integer currentFloorNo = SharedVariableManager.addVariable("currentFloorNo", new integer(1));

   recid cRoom = UndoableFactory.recid();

   integer rFloor = UndoableFactory.integer((long) 0);

   integer rNo = UndoableFactory.integer((long) 0);

   integer rType = UndoableFactory.integer((long) 0);

   logical rState = UndoableFactory.logical(true);

   date rStateDate = UndoableFactory.date();

   integer rNo2 = UndoableFactory.integer();

   integer floorNo = UndoableFactory.integer();

   /**
    * External procedure (converted to Java from the 4GL source code
    * in rooms.p).
    */
   public void execute()
   {
      character hTime = UndoableFactory.character();
      character selection = UndoableFactory.character(null);
      character sprog = UndoableFactory.character(null);
      logical isOk = UndoableFactory.logical();
      
      externalProcedure(Rooms.this, new Block((Body) () -> 
      {
         fFloorNoFrame.widgetFloorNo().setValidation(((ValidationExpr<integer>) (integer floorNo_) -> and(isGreaterThanOrEqual(floorNo_, 1), () -> isLessThanOrEqual(floorNo_, totalFloorNo))), ((ValidationMsg<integer>) (integer floorNo_) -> concat("Floor number must be between 1 and ", valueOf(totalFloorNo))));
         fFindFrame.widgetRNo2().setValidation(((ValidationExpr<integer>) (integer rNo2_) -> new FindQuery(room, "room.roomNumber = ?", null, "room.roomNumber asc", new Object[]
         {
            rNo2_
         }, LockType.NONE).hasAny()), "Room number doesn't exist!");
         fMainHeaderFrame.openScope();
         fRoomFrame.openScope();
         RecordBuffer.openScope(room, roomState);
         progStarted.assign(true);
         screenTitle.assign("Room Management");
         ErrorManager.silentErrorEnable();
         new FindQuery(room, "room.floor = ?", null, "room.roomNumber asc", new Object[]
         {
            currentFloorNo
         }, LockType.NONE).first();
         ErrorManager.silentErrorDisable();
         cRoom.assign((room._available() ? room.recordID() : new recid()));
         ControlFlowOps.invokeWithMode("set-room-types-combo", "I", fRoomFrame.widgetRType().asWidgetHandle());
         
         fRoomFrame.view();
         ControlFlowOps.invoke("refresh");
         
         repeat("proc", new Block((Init) () -> 
         {
            fFindFrame.openScope();
            fFloorNoFrame.openScope();
            RecordBuffer.openScope(bRoom2, bRoomState2);
         }, 
         (Body) () -> 
         {
            if (_or(isUnknown(uName), () -> isEqual(uName, "")))
            {
               messageBox("You are not logged in - access denied", ALERT_MESSAGE, BTN_OK, (String) null);
               quit();
            }
            
            hTime.assign(valueOf(datetimetz.now(), "99/99/99 HH:MM:SS"));
            hTime.assign(substring(hTime, 10));
            
            doBlock("blockLabel0", new Block((Body) () -> 
            {
               fMainHeaderFrame.widgetUName().setColumn(new decimal(new integer(1)));
               fMainHeaderFrame.widgetScreenTitle().setColumn(plus(plus(fMainHeaderFrame.widgetUName().getColumn(), length(uName)), divide(minus(minus(minus(fMainHeaderFrame.getWidthChars(), length(uName)), length(screenTitle)), length(hTime)), 2)));
               fMainHeaderFrame.widgetHTime().setColumn(minus(fMainHeaderFrame.getWidthChars(), length(hTime)));
               fMainHeaderFrame.widgetScreenTitle().setFormat(concat("x(", valueOf(length(screenTitle)), ")"));
            }));
            
            FrameElement[] elementList1 = new FrameElement[]
            {
               new Element(uName, fMainHeaderFrame.widgetUName()),
               new Element(screenTitle, fMainHeaderFrame.widgetScreenTitle()),
               new Element(hTime, fMainHeaderFrame.widgetHTime())
            };
            
            fMainHeaderFrame.display(elementList1);
            
            sprog.setUnknown();
            
            switch (StringHelper.safeTrimTrailing((selection).toStringMessage()).toUpperCase())
            {
               case "P":
                  {
                     ErrorManager.silentErrorEnable();
                     new FindQuery(room, "room.floor = ?", null, "room.roomNumber asc", new Object[]
                     {
                        currentFloorNo
                     }, LockType.NONE).previous();
                     ErrorManager.silentErrorDisable();
                     
                     if (room._available())
                     {
                        cRoom.assign(room.recordID());
                        ControlFlowOps.invoke("refresh");
                     }
                  }
                  break;
               case "N":
                  {
                     ErrorManager.silentErrorEnable();
                     new FindQuery(room, "room.floor = ?", null, "room.roomNumber asc", new Object[]
                     {
                        currentFloorNo
                     }, LockType.NONE).next();
                     ErrorManager.silentErrorDisable();
                     
                     if (room._available())
                     {
                        cRoom.assign(room.recordID());
                        ControlFlowOps.invoke("refresh");
                     }
                  }
                  break;
               case "F":
                  {
                     ErrorManager.silentErrorEnable();
                     new FindQuery(room, "room.floor = ?", null, "room.roomNumber asc", new Object[]
                     {
                        currentFloorNo
                     }, LockType.NONE).first();
                     ErrorManager.silentErrorDisable();
                     
                     if (room._available())
                     {
                        cRoom.assign(room.recordID());
                        ControlFlowOps.invoke("refresh");
                     }
                  }
                  break;
               case "L":
                  {
                     ErrorManager.silentErrorEnable();
                     new FindQuery(room, "room.floor = ?", null, "room.roomNumber asc", new Object[]
                     {
                        currentFloorNo
                     }, LockType.NONE).last();
                     ErrorManager.silentErrorDisable();
                     
                     if (room._available())
                     {
                        cRoom.assign(room.recordID());
                        ControlFlowOps.invoke("refresh");
                     }
                  }
                  break;
               case "I":
                  {
                     OnPhrase[] onPhrase0 = new OnPhrase[]
                     {
                        new OnPhrase(Condition.ENDKEY, Action.LEAVE, "blockLabel1")
                     };
                     
                     doBlock(TransactionType.SUB, "blockLabel1", onPhrase0, new Block((Body) () -> 
                     {
                        FrameElement[] elementList2 = new FrameElement[]
                        {
                           new Element(rNo2, fFindFrame.widgetRNo2())
                        };
                        
                        fFindFrame.update(elementList2);
                     }));
                     
                     fFindFrame.hide(true);
                     
                     ErrorManager.silentErrorEnable();
                     new FindQuery(room, "room.roomNumber = ?", null, "room.roomNumber asc", new Object[]
                     {
                        rNo2
                     }, LockType.NONE).unique();
                     ErrorManager.silentErrorDisable();
                     
                     if (room._available())
                     {
                        cRoom.assign(room.recordID());
                        currentFloorNo.assign(room.getFloor());
                        ControlFlowOps.invoke("refresh");
                     }
                  }
                  break;
               case "D":
                  {
                     if (_notUnknown(cRoom))
                     {
                        new FindQuery(bRoom2, "bRoom2.id = ?", null, "bRoom2.roomNumber asc", new Object[]
                        {
                           cRoom
                        }).unique();
                        ErrorManager.silentErrorEnable();
                        new FindQuery(bRoomState2, "bRoomState2.roomNumber = ?", null, "bRoomState2.id asc", new Object[]
                        {
                           bRoom2.getRoomNumber()
                        }, LockType.NONE).unique();
                        ErrorManager.silentErrorDisable();
                        
                        if (_and(bRoomState2.available(), () -> not(bRoomState2.isState())))
                        {
                           messageBox("The room is already inactive", ALERT_MESSAGE, BTN_OK, (String) null);
                        }
                        else
                        {
                           messageBox(new Object[]
                           {
                              "Deactivate room starting with",
                              date.today(),
                              "?"
                           }, false, new AccessorWrapper(isOk), ALERT_MESSAGE, BTN_YES_NO, (String) null);
                           
                           if ((isOk).booleanValue())
                           {
                              if (_and(bRoomState2.available(), () -> isEqual(bRoomState2.getStartDate(), date.today())))
                              {
                                 doBlock(TransactionType.FULL, "blockLabel2", new Block((Body) () -> 
                                 {
                                    new FindQuery(bRoomState2, (String) null, null, "bRoomState2.id asc", LockType.EXCLUSIVE).current();
                                    bRoomState2.setState(new logical(false));
                                 }));
                              }
                              else
                              {
                                 doBlock(TransactionType.FULL, "blockLabel3", new Block((Body) () -> 
                                 {
                                    bRoomState2.create();
                                    bRoomState2.setRoomNumber(bRoom2.getRoomNumber());
                                    bRoomState2.setState(new logical(false));
                                    bRoomState2.setStartDate(date.today());
                                 }));
                              }
                           }
                        }
                     }
                     ControlFlowOps.invoke("refresh");
                  }
                  break;
               case "A":
                  {
                     bRoom2.release();
                     
                     if (_notUnknown(cRoom))
                     {
                        new FindQuery(bRoom2, "bRoom2.id = ?", null, "bRoom2.roomNumber asc", new Object[]
                        {
                           cRoom
                        }).unique();
                        ErrorManager.silentErrorEnable();
                        new FindQuery(bRoomState2, "bRoomState2.roomNumber = ?", null, "bRoomState2.id asc", new Object[]
                        {
                           bRoom2.getRoomNumber()
                        }, LockType.NONE).unique();
                        ErrorManager.silentErrorDisable();
                        
                        if (_and(bRoomState2.available(), () -> (logical) bRoomState2.isState()))
                        {
                           messageBox("The room is already active", ALERT_MESSAGE, BTN_OK, (String) null);
                        }
                        else
                        {
                           messageBox(new Object[]
                           {
                              "Activate room starting with",
                              date.today(),
                              "?"
                           }, false, new AccessorWrapper(isOk), ALERT_MESSAGE, BTN_YES_NO, (String) null);
                           
                           if ((isOk).booleanValue())
                           {
                              if (_and(bRoomState2.available(), () -> isEqual(bRoomState2.getStartDate(), date.today())))
                              {
                                 doBlock(TransactionType.FULL, "blockLabel4", new Block((Body) () -> 
                                 {
                                    new FindQuery(bRoomState2, (String) null, null, "bRoomState2.id asc", LockType.EXCLUSIVE).current();
                                    bRoomState2.setState(new logical(true));
                                 }));
                              }
                              else
                              {
                                 doBlock(TransactionType.FULL, "blockLabel5", new Block((Body) () -> 
                                 {
                                    bRoomState2.create();
                                    bRoomState2.setRoomNumber(bRoom2.getRoomNumber());
                                    bRoomState2.setState(new logical(true));
                                    bRoomState2.setStartDate(date.today());
                                 }));
                              }
                           }
                        }
                     }
                     ControlFlowOps.invoke("refresh");
                  }
                  break;
               case "S":
                  {
                     OnPhrase[] onPhrase1 = new OnPhrase[]
                     {
                        new OnPhrase(Condition.ENDKEY, Action.LEAVE, "blockLabel6")
                     };
                     
                     doBlock(TransactionType.SUB, "blockLabel6", onPhrase1, new Block((Body) () -> 
                     {
                        floorNo.assign(currentFloorNo);
                        
                        FrameElement[] elementList3 = new FrameElement[]
                        {
                           new Element(floorNo, fFloorNoFrame.widgetFloorNo())
                        };
                        
                        fFloorNoFrame.update(elementList3);
                        
                        fFloorNoFrame.hide(true);
                        
                        currentFloorNo.assign(floorNo);
                     }));
                     
                     ErrorManager.silentErrorEnable();
                     new FindQuery(room, "room.floor = ?", null, "room.roomNumber asc", new Object[]
                     {
                        currentFloorNo
                     }, LockType.NONE).first();
                     ErrorManager.silentErrorDisable();
                     
                     if (_not(room.available()))
                     {
                        cRoom.setUnknown();
                        message("No more rooms");
                     }
                     else
                     {
                        cRoom.assign(room.recordID());
                     }
                     
                     ControlFlowOps.invoke("refresh");
                  }
                  break;
               case "O":
                  {
                     sprog.assign("rooms-overview.p");
                  }
                  break;
               case "M":
                  {
                     ControlFlowOps.invoke("rooms-add.p");
                     ErrorManager.silentErrorEnable();
                     new FindQuery(room, "room.floor = ?", null, "room.roomNumber asc", new Object[]
                     {
                        currentFloorNo
                     }, LockType.NONE).first();
                     ErrorManager.silentErrorDisable();
                     
                     if (room._available())
                     {
                        cRoom.assign(room.recordID());
                        ControlFlowOps.invoke("refresh");
                     }
                  }
                  break;
               case "R":
                  {
                     NamedEventManager.publish("pop-program", thisProcedure());
                     leave("proc");
                  }
               case "U":
                  {
                     if (_notUnknown(cRoom))
                     {
                        doBlock(TransactionType.FULL, "blockLabel7", new Block((Body) () -> 
                        {
                           FrameElement[] elementList4 = new FrameElement[]
                           {
                              new Element(rType, fRoomFrame.widgetRType())
                           };
                           
                           fRoomFrame.update(elementList4);
                           
                           new FindQuery(bRoom2, "bRoom2.id = ?", null, "bRoom2.roomNumber asc", new Object[]
                           {
                              cRoom
                           }, LockType.EXCLUSIVE).unique();
                           bRoom2.setTypeOfRoom(rType);
                        }));
                     }
                  }
                  break;
               default:
                  {
                     if (_notUnknown(selection))
                     {
                        message("Invalid selection - try again");
                        selection.setUnknown();
                        pause();
                        next("proc");
                     }
                  }
                  break;
            }
            
            if (_notUnknown(sprog))
            {
               leave("proc");
            }
            
            selection.assign("R");
            
            OnPhrase[] onPhrase2 = new OnPhrase[]
            {
               new OnPhrase(Condition.ENDKEY, Action.LEAVE, "choice")
            };
            
            repeat("choice", onPhrase2, new Block((Body) () -> 
            {
               hideMessage(true);
               
               message("(P)rev   (N)ext   (F)irst   (L)ast   (D)eactivate   (A)ctivate");
               message("(S)et Floor No   F(i)nd   (O)verview   Add Roo(m)s   (U)pdate   (R)eturn", false, new AccessorWrapper(selection), true, "x(1)");
               selection.assign(toUpperCase(selection));
               leave("choice");
            }));
         }));
         
         if (_notUnknown(sprog))
         {
            NamedEventManager.publish("push-program", thisProcedure(), "I", new Object[]
            {
               sprog
            });
         }
      }));
   }

   public void refresh()
   {
      Room.Buf bRoom = RecordBuffer.define(Room.Buf.class, "hotel", "bRoom", "b-room");
      
      internalProcedure(new Block((Body) () -> 
      {
         RecordBuffer.openScope(bRoom);
         
         if (_isUnknown(cRoom))
         {
            fRoomFrame.clearAll(true);
            returnNormal();
         }
         
         new FindQuery(bRoom, "bRoom.id = ?", null, "bRoom.roomNumber asc", new Object[]
         {
            cRoom
         }, LockType.NONE).unique();
         rFloor.assign(bRoom.getFloor());
         rNo.assign(bRoom.getRoomNumber());
         rType.assign(bRoom.getTypeOfRoom());
         ErrorManager.silentErrorEnable();
         /* find room state*/
         new FindQuery(roomState, "roomState.roomNumber = ? and roomState.startDate <= ?", null, "roomState.id asc", new Object[]
         {
            bRoom.getRoomNumber(),
            (P2JQuery.Parameter) () -> date.today()
         }, LockType.NONE).last();
         ErrorManager.silentErrorDisable();
         
         if (roomState._available())
         {
            rStateDate.assign(roomState.getStartDate());
            rState.assign(roomState.isState());
         }
         else
         {
            rStateDate.assign(date.today());
            rState.assign(true);
         }
         
         FrameElement[] elementList0 = new FrameElement[]
         {
            new Element(rFloor, fRoomFrame.widgetRFloor()),
            new Element(rNo, fRoomFrame.widgetRNo()),
            new Element(rType, fRoomFrame.widgetRType()),
            new Element(rState, fRoomFrame.widgetRState()),
            new Element(rStateDate, fRoomFrame.widgetRStateDate())
         };
         
         fRoomFrame.display(elementList0);
      }));
   }
}
