package com.goldencode.hotel;

import com.goldencode.p2j.util.*;
import com.goldencode.hotel.ui.*;
import com.goldencode.p2j.ui.*;
import com.goldencode.p2j.persist.*;
import com.goldencode.hotel.dmo.hotel.*;
import com.goldencode.p2j.persist.lock.*;
import java.util.function.*;

import static com.goldencode.p2j.util.BlockManager.*;
import static com.goldencode.p2j.util.MathOps.*;
import static com.goldencode.p2j.util.CompareOps.*;
import static com.goldencode.p2j.util.logical.*;
import static com.goldencode.p2j.util.TextOps.*;
import static com.goldencode.p2j.util.character.*;
import static com.goldencode.p2j.ui.LogicalTerminal.*;

/**
 * Business logic (converted to Java from the 4GL source code
 * in rooms-add.p).
 */
public class RoomsAdd
{
   Room.Buf room = RecordBuffer.define(Room.Buf.class, "hotel", "room", "room");

   RoomsAddF1 f1Frame = GenericFrame.createFrame(RoomsAddF1.class, "f1");

   logical progStarted = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "progStarted", new logical(false));

   character uName = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "uName", new character(""));

   character screenTitle = SharedVariableManager.lookupVariable("screenTitle", character.class);

   integer currentFloorNo = SharedVariableManager.lookupVariable("currentFloorNo", integer.class);

   integer startNo = UndoableFactory.integer();

   integer endNo = UndoableFactory.integer();

   integer roomType = UndoableFactory.integer();

   /**
    * External procedure (converted to Java from the 4GL source code
    * in rooms-add.p).
    */
   public void execute()
   {
      externalProcedure(RoomsAdd.this, new Block((Body) () -> 
      {
         f1Frame.widgetEndNo().setValidation(((ValidationExpr<integer>) (integer endNo_) -> and(isGreaterThanOrEqual(endNo_, 1), () -> isLessThanOrEqual(endNo_, 99))), "Room number is between 1 and 99");
         f1Frame.widgetStartNo().setValidation(((ValidationExpr<integer>) (integer startNo_) -> and(isGreaterThanOrEqual(startNo_, 1), () -> isLessThanOrEqual(startNo_, 99))), "Room number is between 1 and 99");
         f1Frame.openScope();
         RecordBuffer.openScope(room);
         progStarted.assign(true);
         screenTitle.assign("Add Rooms");
         ControlFlowOps.invokeWithMode("set-room-types-combo", "I", f1Frame.widgetRoomType().asWidgetHandle());
         registerTrigger(new EventList("choose", f1Frame.widgetBtnOk()), TriggerBlock0.class, RoomsAdd.this);
         
         FrameElement[] elementList0 = new FrameElement[]
         {
            new Element(currentFloorNo, f1Frame.widgetCurrentFloorNo())
         };
         
         f1Frame.display(elementList0);
         
         f1Frame.enable();
         
         LogicalTerminal.waitFor(f1Frame, new EventList("go", f1Frame.asWidget()));
      }));
   }

   public class TriggerBlock0
   extends Trigger
   {
      integer rNo = UndoableFactory.integer();

      integer sNo = UndoableFactory.integer();

      integer eNo = UndoableFactory.integer();

      integer a = UndoableFactory.integer();

      public void body()
      {
         f1Frame.assignScreenValue(new Element(startNo, f1Frame.widgetStartNo()));
         f1Frame.assignScreenValue(new Element(endNo, f1Frame.widgetEndNo()));
         f1Frame.assignScreenValue(new Element(roomType, f1Frame.widgetRoomType()));
         f1Frame.assignScreenValue(new Element(currentFloorNo, f1Frame.widgetCurrentFloorNo()));
         
         if (_isGreaterThan(startNo, endNo))
         {
            messageBox("Start number must be less than end room number", ALERT_MESSAGE, BTN_OK, (String) null);
            returnNormal();
         }
         
         sNo.assign(plus(multiply(currentFloorNo, 100), startNo));
         eNo.assign(plus(multiply(currentFloorNo, 100), endNo));
         message(new Object[]
         {
            "Adding rooms from",
            sNo,
            "to",
            eNo
         });
         
         ToClause toClause0 = new ToClause(rNo, sNo, eNo);
         
         doTo(TransactionType.FULL, "loopLabel0", toClause0, new Block((Body) () -> 
         {
            ErrorManager.silentErrorEnable();
            new FindQuery(room, "room.floor = ? and room.roomNumber = ?", null, "room.roomNumber asc", new Object[]
            {
               currentFloorNo,
               rNo
            }, LockType.NONE).unique();
            ErrorManager.silentErrorDisable();
            
            if (room._available())
            {
               statusDefault(concat("Skipping room ", valueOf(rNo)));
               KeyReader.readKey(1);
               next("loopLabel0");
            }
            
            statusDefault(concat("Adding room", valueOf(rNo)));
            room.create();
            room.setFloor(currentFloorNo);
            room.setRoomNumber(rNo);
            room.setTypeOfRoom(roomType);
            a.assign(plus(a, 1));
         }));
         
         message(concat("Added ", valueOf(a), new character(" rooms")));
         pause();
         statusDefault();
         f1Frame.apply("go");
      }
   }
}
