package com.goldencode.hotel;

import com.goldencode.p2j.util.*;
import com.goldencode.hotel.ui.*;
import com.goldencode.p2j.ui.*;
import com.goldencode.p2j.persist.*;
import com.goldencode.hotel.dmo.hotel.*;
import com.goldencode.util.*;
import com.goldencode.p2j.persist.lock.*;

import static com.goldencode.p2j.util.BlockManager.*;
import static com.goldencode.p2j.util.CompareOps.*;
import static com.goldencode.p2j.util.MathOps.*;
import static com.goldencode.p2j.util.logical.*;
import static com.goldencode.p2j.util.TextOps.*;
import static com.goldencode.p2j.util.ProcedureManager.*;
import static com.goldencode.p2j.util.ArrayAssigner.*;
import static com.goldencode.p2j.util.character.*;
import static com.goldencode.p2j.ui.LogicalTerminal.*;

/**
 * Business logic (converted to Java from the 4GL source code
 * in rooms-overview.p).
 */
public class RoomsOverview
{
   Room.Buf room = RecordBuffer.define(Room.Buf.class, "hotel", "room", "room");

   RoomsOverviewFMainHeader fMainHeaderFrame = GenericFrame.createFrame(RoomsOverviewFMainHeader.class, "f-main-header");

   RoomsOverviewFRoomOverview fRoomOverviewFrame = GenericFrame.createFrame(RoomsOverviewFRoomOverview.class, "f-room-overview");

   logical progStarted = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "progStarted", new logical(false));

   character uName = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "uName", new character(""));

   character screenTitle = SharedVariableManager.lookupVariable("screenTitle", character.class);

   integer totalFloorNo = SharedVariableManager.lookupVariable("totalFloorNo", integer.class);

   character[] roomTypes = SharedVariableManager.lookupVariable("roomTypes", character.class, 5);

   /**
    * External procedure (converted to Java from the 4GL source code
    * in rooms-overview.p).
    */
   public void execute()
   {
      character hTime = UndoableFactory.character();
      character fheader = UndoableFactory.character();
      integer i = UndoableFactory.integer();
      integer j = UndoableFactory.integer();
      integer c = UndoableFactory.integer();
      integer r = UndoableFactory.integer();
      handle hfi = UndoableFactory.handle();
      handle hsl = UndoableFactory.handle();
      integer colSize = UndoableFactory.integer();
      character fsep = UndoableFactory.character();
      integer maxrt = UndoableFactory.integer((long) 0);
      character selection = UndoableFactory.character();
      
      externalProcedure(RoomsOverview.this, new Block((Body) () -> 
      {
         fMainHeaderFrame.openScope();
         fRoomOverviewFrame.openScope();
         RecordBuffer.openScope(room);
         progStarted.assign(true);
         screenTitle.assign("Room Overview");
         
         if (_or(isUnknown(uName), () -> isEqual(uName, "")))
         {
            messageBox("You are not logged in - access denied", ALERT_MESSAGE, BTN_OK, (String) null);
            quit();
         }
         
         hTime.assign(valueOf(datetimetz.now(), "99/99/99 HH:MM:SS"));
         hTime.assign(substring(hTime, 10));
         
         doBlock("blockLabel0", new Block((Body) () -> 
         {
            fMainHeaderFrame.widgetUName().setColumn(new decimal(new integer(1)));
            fMainHeaderFrame.widgetScreenTitle().setColumn(plus(plus(fMainHeaderFrame.widgetUName().getColumn(), length(uName)), divide(minus(minus(minus(fMainHeaderFrame.getWidthChars(), length(uName)), length(screenTitle)), length(hTime)), 2)));
            fMainHeaderFrame.widgetHTime().setColumn(minus(fMainHeaderFrame.getWidthChars(), length(hTime)));
            fMainHeaderFrame.widgetScreenTitle().setFormat(concat("x(", valueOf(length(screenTitle)), ")"));
         }));
         
         FrameElement[] elementList0 = new FrameElement[]
         {
            new Element(uName, fMainHeaderFrame.widgetUName()),
            new Element(screenTitle, fMainHeaderFrame.widgetScreenTitle()),
            new Element(hTime, fMainHeaderFrame.widgetHTime())
         };
         
         fMainHeaderFrame.display(elementList0);
         
         fsep.assign(fill("-", 78));
         colSize.assign(divide(78, totalFloorNo));
         
         loopLabel1:
         for (i.assign(1); _isLessThanOrEqual(i, totalFloorNo); i.increment())
         {
            fheader.assign(concat(fheader, "Floor ", valueOf(i), fill(" ", minus(colSize, length("floor n")))));
         }
         
         loopLabel2:
         for (i.assign(1); _isLessThanOrEqual(i, roomTypes.length); i.increment())
         {
            maxrt.assign(integer.maximum(maxrt, length(subscript(roomTypes, i))));
         }
         
         FrameElement[] elementList1 = new FrameElement[]
         {
            new Element(fheader, fRoomOverviewFrame.widgetFheader()),
            new Element(fsep, fRoomOverviewFrame.widgetFsep())
         };
         
         fRoomOverviewFrame.display(elementList1);
         
         WidgetPool.create();
         
         loopLabel3:
         for (i.assign(1); _isLessThanOrEqual(i, totalFloorNo); i.increment())
         {
            c.assign(plus(multiply(minus(i, 1), colSize), 1));
            
            ToClause toClause0 = new ToClause(j, 1, roomTypes.length);
            
            doTo("loopLabel4", toClause0, new Block((Body) () -> 
            {
               r.assign(plus(j, 2));
               DynamicWidgetFactory.createText(hfi);
               hfi.unwrapWidget().setFrameHandle(fRoomOverviewFrame.asWidgetHandle());
               hfi.unwrapWidget().setRow(new decimal(r));
               hfi.unwrapWidget().setColumn(new decimal(plus(plus(c, maxrt), 4)));
               hfi.unwrapCommonField().setDataType(new character("integer"));
               hfi.unwrapCommonField().setFormat(new character(">>>"));
               hfi.unwrapWidget().setVisible(new logical(true));
               hfi.unwrapWidget().setScreenValue(valueOf(getTotalRooms(j, i)));
               DynamicWidgetFactory.createText(hsl);
               hsl.unwrapWidget().setRow(new decimal(r));
               hsl.unwrapWidget().setColumn(new decimal(c));
               hsl.unwrapWidget().setFrameHandle(fRoomOverviewFrame.asWidgetHandle());
               hsl.unwrapCommonField().setFormat(concat("x(", valueOf(maxrt), ")"));
               hsl.unwrapWidget().setScreenValue(subscript(roomTypes, j));
               hsl.unwrapWidget().setVisible(new logical(true));
               hfi.unwrapWidget().setSideLabelHandle(hsl);
            }));
         }
         
         selection.setUnknown();
         
         repeat("proc", new Block((Body) () -> 
         {
            switch (StringHelper.safeTrimTrailing((selection).toStringMessage()).toUpperCase())
            {
               case "R":
                  {
                     leave("proc");
                  }
               default:
                  {
                     if (_notUnknown(selection))
                     {
                        message("Invalid selection - try again");
                        selection.setUnknown();
                        pause();
                        next("proc");
                     }
                  }
                  break;
            }
            selection.assign("R");
            
            OnPhrase[] onPhrase0 = new OnPhrase[]
            {
               new OnPhrase(Condition.ENDKEY, Action.LEAVE, "choice")
            };
            
            repeat("choice", onPhrase0, new Block((Body) () -> 
            {
               hideMessage(true);
               
               message("");
               message("(R)eturn", false, new AccessorWrapper(selection), true, "x(1)");
               selection.assign(toUpperCase(selection));
               leave("choice");
            }));
         }));
         
         NamedEventManager.publish("pop-program", thisProcedure());
      }));
   }

   /**
    * view main room screen
    */
   public integer getTotalRooms(final integer _roomType, final integer _fNo)
   {
      integer roomType = TypeFactory.initInput(_roomType);
      integer fNo = TypeFactory.initInput(_fNo);
      integer n = UndoableFactory.integer();
      
      return function("get-total-rooms", integer.class, new Block((Body) () -> 
      {
         AdaptiveQuery query0 = new AdaptiveQuery();
         
         forEach("loopLabel0", new Block((Init) () -> 
         {
            query0.initialize(room, "room.typeOfRoom = ? and room.floor = ?", null, "room.roomNumber asc", new Object[]
            {
               roomType,
               fNo
            });
         }, 
         (Body) () -> 
         {
            query0.next();
            n.assign(plus(n, 1));
         }));
         
         returnNormal(n);
      }));
   }
}
